
_TEXT           SEGMENT BYTE PUBLIC 'CODE'

        ASSUME  CS:_TEXT

PLANO_LECTURA   DB      0
PLANO_ESCRITURA DB      0

                PUBLIC  _BORRA_ZONA_PANTALLA

_BORRA_ZONA_PANTALLA    PROC    NEAR
                PUSH    DI
                PUSH    ES

                MOV     DX,3CEh         ;modo de escritura 0
                MOV     AX,0005h
                OUT     DX,AX

                MOV     DX,3C4h         ;selecciona bit-plane de escritura
                MOV     AX,0F02h
                OUT     DX,AX

                CLD
                MOV     AX,0A000h
                MOV     ES,AX
                MOV     DI,80*480
                MOV     CX,80*339
                XOR     AL,AL
                REP     STOSB

                POP     ES
                POP     DI
                RET
_BORRA_ZONA_PANTALLA    ENDP

                PUBLIC  _DIBUJA_SPRITE

_DIBUJA_SPRITE  PROC    NEAR
                PUSH    BP
                MOV     BP,SP
                PUSH    SI
                PUSH    DI
                PUSH    DS
                PUSH    ES

                LDS     SI,[BP+4]
                MOV     AX,0A000h
                MOV     ES,AX
                MOV     DI,80*480

                MOV     AX,[BP+10]      ;calcula direccion origen
                MOV     DX,80*4
                MUL     DX
                ADD     AX,[BP+8]
                ADD     SI,AX

                MOV     AX,[BP+14]      ;calcula direccion destino
                MOV     DX,80
                MUL     DX
                ADD     AX,[BP+12]
                ADD     DI,AX

                MOV     DX,3CEh         ;modo de escritura 0
                MOV     AX,0005h
                OUT     DX,AX

                MOV     BX,[BP+18]      ;alto
                CLD
                MOV     AH,00010001b    ;bit plane de escritura

OTRA_LINEA:     MOV     DX,3C4h         ;selecciona bit-plane de escritura
                MOV     AL,02h
                OUT     DX,AX

                MOV     CX,[BP+16]      ;ancho
                REP     MOVSB
                SUB     SI,[BP+16]
                ADD     SI,80
                SUB     DI,[BP+16]
                ROL     AH,1
                JNC     OTRA_LINEA
                ADD     DI,80
                DEC     BX
                JNZ     OTRA_LINEA

                POP     ES
                POP     DS
                POP     DI
                POP     SI
                POP     BP
                RET
_DIBUJA_SPRITE  ENDP

                PUBLIC  _DIBUJA_SPRITE_MASK

_DIBUJA_SPRITE_MASK     PROC    NEAR
                PUSH    BP
                MOV     BP,SP
                PUSH    SI
                PUSH    DI
                PUSH    DS
                PUSH    ES

                LDS     SI,[BP+4]
                MOV     BX,SI
                MOV     AX,0A000h
                MOV     ES,AX
                MOV     DI,80*480

                MOV     AX,[BP+10]      ;calcula direccion origen
                MOV     DX,80*4
                MUL     DX
                ADD     AX,[BP+8]
                ADD     SI,AX

                MOV     AX,[BP+14]      ;calcula direccion mascara
                MOV     DX,80*4
                MUL     DX
                ADD     AX,[BP+12]
                ADD     BX,AX

                MOV     AX,[BP+18]      ;calcula direccion destino
                MOV     DX,80
                MUL     DX
                ADD     AX,[BP+16]
                ADD     DI,AX

                MOV     DX,3CEh         ;modo de escritura 0
                MOV     AX,0005h
                OUT     DX,AX

                MOV     DX,[BP+22]      ;alto
                CLD
                MOV     CS:[PLANO_LECTURA],0
                MOV     CS:[PLANO_ESCRITURA],00010001b

OTRA_LINE:      PUSH    DX
                MOV     DX,3CEh         ;selecciona bit-plane de lectura
                MOV     AL,04h
                MOV     AH,CS:[PLANO_LECTURA]
                OUT     DX,AX

                MOV     DX,3C4h         ;selecciona bit-plane de escritura
                MOV     AL,02h
                MOV     AH,CS:[PLANO_ESCRITURA]
                OUT     DX,AX
                POP     DX

                MOV     CX,[BP+20]      ;ancho
SIG_BYTE:       MOV     AL,ES:[DI]
                AND     AL,[BX]
                OR      AL,[SI]
                MOV     ES:[DI],AL
                INC     SI
                INC     BX
                INC     DI
                LOOP    SIG_BYTE
                SUB     SI,[BP+20]
                ADD     SI,80
                SUB     BX,[BP+20]
                ADD     BX,80
                SUB     DI,[BP+20]
                INC     CS:[PLANO_LECTURA]
                AND     CS:[PLANO_LECTURA],3
                ROL     CS:[PLANO_ESCRITURA],1
                JNC     OTRA_LINE
                ADD     DI,80
                DEC     DX
                JNZ     OTRA_LINE

                POP     ES
                POP     DS
                POP     DI
                POP     SI
                POP     BP
                RET
_DIBUJA_SPRITE_MASK     ENDP

                PUBLIC  _VUELCA_PANTALLA

_VUELCA_PANTALLA        PROC    NEAR
                PUSH    SI
                PUSH    DI
                PUSH    DS
                PUSH    ES

                MOV     DX,3CEh                 ;modo de escritura 1
                MOV     AX,0105h
                OUT     DX,AX

                MOV     DX,3C4h                 ;habilita todos los bit-planes
                MOV     AX,0F02h
                OUT     DX,AX

                MOV     AX,0A000h               ;direccion de la pantalla donde
                MOV     DS,AX                   ;se construyen los sprites
                MOV     SI,80*480

                MOV     AX,0A000h               ;direccion de la pantalla de
                MOV     ES,AX                   ;visualizacion
                MOV     DI,0

                CLD
                MOV     CX,80*339
                REP     MOVSB

                POP     ES
                POP     DS
                POP     DI
                POP     SI
                RET
_VUELCA_PANTALLA        ENDP

_TEXT           ENDS

                END

